var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
import { ClientType } from "@streamdal/snitch-protos/protos/sp_info";
// import { version } from "../../package.json";
import { processResponse } from "./pipeline.js";
//
// fyi, the init flag is because we can't await pipeline initialization
// in our constructor so we do it on processPipeline only if needed
export const internal = {
    pipelineInitialized: false,
    pipelines: new Map(),
    audiences: new Map(),
    wasmModules: new Map(),
};
export const audienceKey = (audience) => JSON.stringify(audience).toLowerCase();
export const register = ({ grpcClient, sessionId, serviceName, streamdalToken, dryRun, audiences, }) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, e_1, _b, _c;
    try {
        console.info(`### registering with grpc server...`);
        const call = grpcClient.register(Object.assign({ sessionId,
            serviceName,
            dryRun, clientInfo: {
                clientType: ClientType.SDK,
                libraryName: "node-sdk",
                libraryVersion: "0.0.1",
                language: "Typescript",
                arch: process.arch,
                os: process.platform,
            } }, (audiences ? { audiences } : { audiences: [] })), {
            meta: { "auth-token": streamdalToken },
        });
        console.info(`### registered with grpc server`);
        try {
            for (var _d = true, _e = __asyncValues(call.responses), _f; _f = yield _e.next(), _a = _f.done, !_a; _d = true) {
                _c = _f.value;
                _d = false;
                const response = _c;
                response.command.oneofKind !== "keepAlive" &&
                    console.debug("processing response command...", response);
                processResponse(response);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (!_d && !_a && (_b = _e.return)) yield _b.call(_e);
            }
            finally { if (e_1) throw e_1.error; }
        }
        //
        // TODO: check status for errors
        // const { status, trailers } = await call;
    }
    catch (error) {
        console.error("Error registering with grpc server", error);
    }
});
